# coding: utf-8

"""
    Docusign eSignature REST API

    The Docusign eSignature REST API provides you with a powerful, convenient, and simple Web services API for interacting with Docusign.  # noqa: E501

    OpenAPI spec version: v2.1
    Contact: devcenter@docusign.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from docusign_esign.client.configuration import Configuration


class DocGenFormFields(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'doc_gen_document_status': 'str',
        'doc_gen_errors': 'list[DocGenSyntaxError]',
        'doc_gen_form_field_list': 'list[DocGenFormField]',
        'document_id': 'str'
    }

    attribute_map = {
        'doc_gen_document_status': 'docGenDocumentStatus',
        'doc_gen_errors': 'docGenErrors',
        'doc_gen_form_field_list': 'docGenFormFieldList',
        'document_id': 'documentId'
    }

    def __init__(self, _configuration=None, **kwargs):  # noqa: E501
        """DocGenFormFields - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._doc_gen_document_status = None
        self._doc_gen_errors = None
        self._doc_gen_form_field_list = None
        self._document_id = None
        self.discriminator = None

        setattr(self, "_{}".format('doc_gen_document_status'), kwargs.get('doc_gen_document_status', None))
        setattr(self, "_{}".format('doc_gen_errors'), kwargs.get('doc_gen_errors', None))
        setattr(self, "_{}".format('doc_gen_form_field_list'), kwargs.get('doc_gen_form_field_list', None))
        setattr(self, "_{}".format('document_id'), kwargs.get('document_id', None))

    @property
    def doc_gen_document_status(self):
        """Gets the doc_gen_document_status of this DocGenFormFields.  # noqa: E501

          # noqa: E501

        :return: The doc_gen_document_status of this DocGenFormFields.  # noqa: E501
        :rtype: str
        """
        return self._doc_gen_document_status

    @doc_gen_document_status.setter
    def doc_gen_document_status(self, doc_gen_document_status):
        """Sets the doc_gen_document_status of this DocGenFormFields.

          # noqa: E501

        :param doc_gen_document_status: The doc_gen_document_status of this DocGenFormFields.  # noqa: E501
        :type: str
        """

        self._doc_gen_document_status = doc_gen_document_status

    @property
    def doc_gen_errors(self):
        """Gets the doc_gen_errors of this DocGenFormFields.  # noqa: E501

          # noqa: E501

        :return: The doc_gen_errors of this DocGenFormFields.  # noqa: E501
        :rtype: list[DocGenSyntaxError]
        """
        return self._doc_gen_errors

    @doc_gen_errors.setter
    def doc_gen_errors(self, doc_gen_errors):
        """Sets the doc_gen_errors of this DocGenFormFields.

          # noqa: E501

        :param doc_gen_errors: The doc_gen_errors of this DocGenFormFields.  # noqa: E501
        :type: list[DocGenSyntaxError]
        """

        self._doc_gen_errors = doc_gen_errors

    @property
    def doc_gen_form_field_list(self):
        """Gets the doc_gen_form_field_list of this DocGenFormFields.  # noqa: E501

          # noqa: E501

        :return: The doc_gen_form_field_list of this DocGenFormFields.  # noqa: E501
        :rtype: list[DocGenFormField]
        """
        return self._doc_gen_form_field_list

    @doc_gen_form_field_list.setter
    def doc_gen_form_field_list(self, doc_gen_form_field_list):
        """Sets the doc_gen_form_field_list of this DocGenFormFields.

          # noqa: E501

        :param doc_gen_form_field_list: The doc_gen_form_field_list of this DocGenFormFields.  # noqa: E501
        :type: list[DocGenFormField]
        """

        self._doc_gen_form_field_list = doc_gen_form_field_list

    @property
    def document_id(self):
        """Gets the document_id of this DocGenFormFields.  # noqa: E501

        Specifies the document ID number that the tab is placed on. This must refer to an existing Document's ID attribute.  # noqa: E501

        :return: The document_id of this DocGenFormFields.  # noqa: E501
        :rtype: str
        """
        return self._document_id

    @document_id.setter
    def document_id(self, document_id):
        """Sets the document_id of this DocGenFormFields.

        Specifies the document ID number that the tab is placed on. This must refer to an existing Document's ID attribute.  # noqa: E501

        :param document_id: The document_id of this DocGenFormFields.  # noqa: E501
        :type: str
        """

        self._document_id = document_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocGenFormFields, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocGenFormFields):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DocGenFormFields):
            return True

        return self.to_dict() != other.to_dict()
